#property copyright "bc"
#property link  ""
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Red
#property indicator_level1    0
#property indicator_level2  100
#property indicator_level3 -100

extern string TimeFrame     = "Current time frame";
extern int    MA_Period     = 5;
extern int    MA_Method     = MODE_LWMA;
extern int    CCI_Period    = 14;
extern int    applied_price = 0; 
extern string ForSymbol     = "";

double CCI_idx[];
double CCI_idt[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,CCI_idx);
   SetIndexBuffer(1,CCI_idt);
      if (ForSymbol=="") ForSymbol = Symbol();
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars"; if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" "+ForSymbol+" smoothed CCI");
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
  {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CCI_idx[0] = limit+1; return(0); }
         if (timeFrame != Period() || ForSymbol!=Symbol())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (i=limit; i>=0; i--)
            {
               int y = iBarShift(ForSymbol,timeFrame,Time[i]);
                  CCI_idx[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",MA_Period,MA_Method,CCI_Period,applied_price,"",0,y);
            }
            return(0);
         }   
         
         
   for(i=limit;i>=0;i--) CCI_idt[i] = iCCI(NULL,0,CCI_Period,applied_price,i);
   for(i=limit;i>=0;i--) CCI_idx[i] = iMAOnArray(CCI_idt,0,MA_Period,0,MA_Method,i); 
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("M" + DoubleToStr(timeFrame,0));
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}